function SS=DetectMIC(P,D,NrD,ME,isCst)
%just one loop, but no specific order
%DetecteMIC2, two loops with specific order

Ms=0.0001;%tolerance for translation ... can be set very good, but just use this value for simplicity.

nP=size(P,2);
[DS,idx]=sort(D);% distance sorting
%generate valid triples and its corresponding errors
SS=[];
nT=0;
nUT=0;
for i=1:nP
    for j=i+1:nP
        for k=j+1:nP
            [id,eMin,eMax,dr,Dr]=TripleError(D,NrD,P,i,j,k,ME);
            if(eMin<0) continue; end        
            nT=nT+1;
            S0=id;
            isExist=0;            
            for ii=1:size(SS,1)
                St=SS{ii,2};
                if(CommonCTriple(S0,St)) isExist=ii; break; end 
                %unexpected case: an incomplete cycle is found (which can be extended in another direction), 
                %and the current triple is part of it
            end     
            if(isExist) continue; end    %zig-zag line and square can still share
            nUT=nUT+1;
            dr0=dr;    Dr0=Dr;
            ns0=3;     c=0;  
            S00=S0;
            %MinSin=sin(2*pi/50);
            [isT,D123]=isTranslation(P(:,S0(1)),P(:,S0(2)),P(:,S0(3)),Ms);           
            while(1)                
                [Pe,c,em,eM,dd,DD,D234]=PointExpansion(S0,c,eMin,eMax,dr,Dr,P,D,NrD,isCst,isT,D123,Ms);%it is determined consistant condition or not
                if(Pe<0)  
                    if(ns0<4& (~isT)) break; end           
%                    if(ns0<=4) break; end        
%                    if(isAmbiguous(S0,eMin,eMax,D,nP)) break; end%check whether the first 3 elements can be replaced. maybe not useful                         
                    SS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,-c,SS,D,P);  %%here c is set to -c         
                    break;
                end
                eMin=em; eMax=eM; dr=dd; Dr=DD;
                ns0=ns0+1;  S0(ns0)=Pe;  D123=D234;
                if(c==ns0&c>=3)
%                    if(~isMax(S0,D,NrD,eMin,c,nP)) break; end           
                    SS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,c,SS,D,P); 
                    break;                
                end
            end
            %end one triple 
        end
    end
end
fprintf('Valid Triple Number: %d.\n', nT)
fprintf('Used Valid Triple Number: %d.\n', nUT)

%DrawRes(P,S3P,4,1,size(sem,2));


function NSS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,c,SS,D,P)    
nP=size(P,2);
NSS=[];
nS0=size(S0,2);
for i=1:size(SS,1)
    Si=SS{i,2};      
    nSi=size(Si,2);
    isSub=isSubset(Si,S0);
    if(~isSub | (size(Si,2)==nS0&isSub))
        s=size(NSS,1)+1;         
        for k=1:size(SS,2)
            NSS{s,k}=SS{i,k};
        end
    end
end
isex=false; 
for i=1:size(SS,1)
    Si=SS{i,2}; 
    if(isSubset(S0,Si)) isex=true; break; end 
    nSi=size(Si,2);             
    te=SS{i,3};
%    if(CommonCTriple(S0,Si)&te<=eMin&nS0<nSi) break; end %three consecutive points s
end
if(~isex)
    s=size(NSS,1)+1;
    NSS{s,1}=S00;
    NSS{s,2}=S0;
    NSS{s,3}=eMin;
    NSS{s,4}=eMax;
    NSS{s,5}=c;        
end

function c=CommonCTriple(S1,St)
c=false;
[IC,ia,ib] = intersect(S1,St);    
if(size(ia,2)<3) c=false; return; end
if(size(S1,2)==3) c=true; return; end
for i=1:size(ia,2)-2        
        if(ia(i+1)-ia(i)==1 & ia(i+2)-ia(i)==2) c=true; end    
end


function [isT,D123]=isTranslation(P1,P2,P3,Ms)
D123=cross(P1-P2,P3-P2);
if(dot(D123,D123)<Ms) isT=true; 
else isT=false; 
end
