function SS=EstimateSymmetryType(SS,P,D)
%inf: translation, glide, screw
%n>=4: rotation, rotation-reflection 
%-2: undetermined cases: four points, 
%n=2: pi-rotation; n=1, reflection 
nP=size(P,2);
MaxRot=50;
for i=1:size(SS,1)
    SSi=SS{i,2};
    c=SS{i,5};
    T=[];
    if(c~=0) 
        T(1)=abs(c); 
        SS{i,6}=T;
        continue; 
    end
    amin=pi;
    amax=0;
    nssi=size(SSi,2);
    if(nssi>=4) %test if a translation and glide case appear
        P13=P(:,SSi(1))-P(:,SSi(3));
        P24=P(:,SSi(2))-P(:,SSi(4));
        d13=D((SSi(1)-1)*nP+SSi(3));
        d24=D((SSi(2)-1)*nP+SSi(4));      
        sangle=abs(dot(P13,P24))/(d13*d24);
        if(sangle>cos(2*pi/MaxRot))
            T(1)=Inf;
            SS{i,6}=T;
            continue; 
        elseif(nssi==4)
            T(1)=-2;
            SS{i,6}=T;
            continue; 
        end    
    end
        
    for j=1:nssi-4%mainly for Cn and Sn case
        i0=SSi(j);
        i1=SSi(j+2);
        i2=SSi(j+4);
        d01=D((i0-1)*nP+i1);
        d02=D((i0-1)*nP+i2);
        d12=D((i1-1)*nP+i2);
        tangle=acos((d01*d01+d12*d12-d02*d02)/(2*d01*d12))*2;
        if((pi-tangle)<2*pi/MaxRot) T(1)=+Inf; SS{i,6}=T; continue; end
        amin=min(amin,tangle);
        amax=max(amax,tangle);
    end
    if((pi-amin)<2*pi/MaxRot) T(1)=+Inf; SS{i,6}=T; continue; end
    n1=floor(2*pi/(pi-amin));
    n2=floor(2*pi/(pi-amax)); 
    T=[n1:n2];
    SS{i,6}=T;
end
