function [id,eMin,eMax,dr,Dr]=TripleError(DS,NrD,P,i,j,k,EM)
%eMin=-1; fail; eMin=0, 3-fold symmetry but not expansible for c-fold
%symmetry
%i0,j0,k0: Pik, maximal distance, Pi>Pk
nP=size(P,2);
eMin=-1; eMax=-1; i0=i; j0=j; k0=k;
dr=0; Dr=0;
id=[];
dij=DS((i-1)*nP+j);
djk=DS((j-1)*nP+k);
dki=DS((k-1)*nP+i);

dS=sort([dij,djk,dki]);
eMin=dS(2)-dS(1);
eMax=min([NrD(i,1),NrD(j,1),NrD(k,1),dS(3)-dS(2),dS(1),EM]);

if(eMin>eMax)  eMin=-1;  return;  end

dr(1)=dS(1);
Dr(1)=dS(2);
dr(2)=dS(3);
Dr(2)=dS(3);

Pi=P(:,i);
Pj=P(:,j);
Pk=P(:,k);

%sort in lex order ...
if(dki>dij& dki>djk)
    j0=j;
    if(isLexOrder(Pi,Pk)) i0=i; k0=k; 
    else i0=k; k0=i;
    end
end    

if(dij>djk& dij>dki) 
    j0=k;        
    if(isLexOrder(Pi,Pj)) i0=i;  k0=j; 
    else i0=j;  k0=i; 
    end
end

if(djk>dki& djk>dij) 
    j0=i;
    if(isLexOrder(Pj,Pk)) i0=j;  k0=k; 
    else i0=k;  k0=j; 
    end
end
id=[i0,j0,k0];