function t=isAmbiguous(S0,eMin,eMax,D,nP)
%check the unambiguity condition for incomplete cycle S0.
t=false;
ns0=size(S0,2);
if(ns0==3) t=true; end
for k=1:3
    tS=S0;
    Dk=D((S0(k)-1)*nP+S0(k+1));
    for i=1:nP
        if(ismember([i],S0)) continue; end
        di=D((i-1)*nP+S0(k+1));
        if(abs(di-Dk)>=eMax) continue; end
        tS(k)=i;
        tem=MinError(tS,eMax,D,nP);  % i should be consistent with S0 as well ... 
        if(tem<eMin-0.0001) 
            t=true; 
            return; 
        end
    end
end


function t=isAmbiguous2(S0,eMin,eMax,D,NrD,nP)
%just checking nearest piont greatly reduces the times
%check the unambiguity condition for incomplete cycle S0.
t=false;
for k=1:1
    tS=S0;    
    nI=NrD(S0(k),2);
    if(ismember([nI],S0)) continue; end
    tS(k)=nI;
    tem=MinError(tS,eMax,D,nP);
    if(tem<eMin-0.001)
        t=true;
        return;             
    end
end

function em=MinError(S,eMax,D,nP)
em=0.;
nS=size(S,2);
for r=1:nS-2
    for i=1:nS-r          
        td=D((S(i)-1)*nP+S(i+r));                            
        if(i==1) dr=td; Dr=td;
        else
            dr=min(dr, td);
            Dr=max(Dr, td); 
            if(Dr-dr>eMax) em=Inf; return; end
        end
    end
    e=Dr-dr;
    em=max(e,em);
end

