function SS=DetectMIC2(P,D,NrD,ME)
nP=size(P,2);
[DS,idx]=sort(D);% distance sorting
%generate valid triples and its corresponding errors
p=1;  S3P=[]; se=[]; dL=[];
for i=1:nP
    for j=i+1:nP
        for k=j+1:nP
            [id,eMin,eMax,dr,Dr]=TripleError(D,NrD,P,i,j,k,ME);
            if(eMin<0) continue; end                      
                S0=id;
                c=0;
                S3P{p}=id;
                sem(p)=eMin;
                seM(p)=eMax;
                sdr{p}=dr;
                sDr{p}=Dr;
                p=p+1;        
        end
    end
end
fprintf('Valid Triple Number: %d.\n',size(sem,2))
%DrawRes(P,S3P,4,1,size(sem,2));

SS=[];
[ses,idx]=sort(sem); % error index 
ns=size(sem,2);
for i=1:ns
    di=idx(ns+1-i);
%    di=idx(i);
    S0=S3P{di};
    S00=S0;
    eMin=sem(di);
    eMax=seM(di);
    dr=sdr{di};
    Dr=sDr{di};
    
    isExist=0;
    for ii=1:size(SS,1)
        St=SS{ii,2};
        if(SS{ii,5}>0) isC=true; else isC=false; end
        if(CommonCTriple(S0,St,isC)) isExist=ii; break; end
    end
    if(isExist) continue; end    %zig-zag line and square can still share
    
    dr0=dr;    Dr0=Dr;
    ns0=3;
    c=0;        
    % one direction 
    while(1)
        [Pe,Pc,c,em,eM,dd,DD]=PointExpansion(S0,c,eMin,eMax,dr,Dr,P,D,NrD,true);
        if(Pe<0) 
            if(ns0<4) break; end        
            if(isAmbiguous(S0,eMin,eMax,D,nP)) break; end%check whether the first 3 elements can be replaced.                         
%            if(isCinCmpS(S0,eMin,SS)) break; end  % this one needs to be reconsidered for differenct cases           
            SS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,-c,SS,D,P);  %%here c is set to -c         
            break;
        end
        eMin=em; eMax=eM; dr=dd; Dr=DD;
        ns0=ns0+1;
        S0(ns0)=Pe;
        if(c==ns0)
            if(~IsMax(S0,D,NrD,eMin,c,nP)) break; end           
            SS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,c,SS,D,P); 
            break; 
         end  
    end
end


function NSS=UpdateSS(S00,S0,eMin,eMax,dr,Dr,c,SS,D,P)    
nP=size(P,2);
NSS=[];
nS0=size(S0,2);
for i=1:size(SS,1)
    Si=SS{i,2};      
    nSi=size(Si,2);
    isSub=isSubset(Si,S0);
    if(~isSub | (size(Si,2)==nS0&isSub))
        s=size(NSS,1)+1;         
        for k=1:size(SS,2)
            NSS{s,k}=SS{i,k};
        end
    end
end
isex=false; 
for i=1:size(SS,1)
    Si=SS{i,2};          
    if(isSubset(S0,Si)) isex=true; break; end 
    te=SS{i,3};
    nSi=size(Si,2);    
    if(CommonCTriple(S0,Si,SS{i,5}>0)&te<=eMin&nS0<nSi) break; end %three consecutive points s
end
if(~isex)
    s=size(NSS,1)+1;
    NSS{s,1}=S00;
    NSS{s,2}=S0;
    NSS{s,3}=eMin;
    NSS{s,4}=eMax;
    NSS{s,5}=c;        
end


%this one is a simple version
function c=CommonCTriple(S1,St,isC)
c=false;
[IC,ia,ib] = intersect(S1,St);    
if(size(ia,2)<3) c=false; return; end
if(size(S1,2)==3) c=true; return; end
for i=1:size(ia,2)-2        
        if(ia(i+1)-ia(i)==1& ia(i+2)-ia(i)==2) c=true; end    
end

function c=CommonCTriple2(S1,St,isC)
%check two sets have three common consecutive points
c=false;
for i=1:size(S1,2)-2
    S0=S1(:,i:i+2);    
    s=false;
    ns=size(St,2);
    for i=1:ns
        if(~isC) 
            if(i<=ns-2)
                if(S0(1)==St(i) & S0(2)==St(i+1) & S0(3)==St(i+2) ) s=true; break; end
            end
        else
            i0=mod(i,ns);       if(i0==0) i0=ns; end
            i1=mod(i+1,ns);     if(i1==0) i1=ns; end
            i2=mod(i+2,ns);     if(i2==0) i2=ns; end
            if(S0(1)==St(i0) & S0(2)==St(i1) & S0(3)==St(i2) ) s=true; break; end
            if(S0(3)==St(i0) & S0(2)==St(i1) & S0(1)==St(i2) ) s=true; break; end%here is important, two directions can appear.
        end    
    end
    if(s) c=true; return; end
end

%it is not used now. 
function t=isCinCmpS(S0,eMin,SS)
t=false;
c2p=0;
nS0=size(S0,2);
for i=1:nS0
    Pi=S0(i);    
    for j=1:size(SS,1)
        St=SS{j,2};
        if(SS{j,5}<=0| SS{j,3}>eMin) continue; end
        if(ismember(Pi,St)) c2p=c2p+1; break; end
    end
end
if(c2p==nS0) t=true; end
